unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, TeeProcs, TeEngine, Chart, TeeComma, StdCtrls, Series,
  TeeTools, StatChar, TeeSeriesBandTool;

type
  TForm1 = class(TForm)
    Chart1: TChart;
    TeeCommander1: TTeeCommander;
    Button1: TButton;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
    Series1     : THorizLineSeries;
    t1          : Double;
    t2          : Double;
    Threshold1  : THorizLineSeries;
    Threshold2  : THorizLineSeries;
    tmpSeries1  : TPointSeries;
    tmpSeries2  : TPointSeries;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

uses TeCanvas;

procedure TForm1.FormCreate(Sender: TObject);
begin
  Series1:=THorizLineSeries.Create(Self);
  Series1.FillSampleValues;

  t1:=Series1.MaxXValue - 100;
  t2:=Series1.MinXValue + 100;

  Threshold1:=THorizLineSeries.Create(Self);
  Threshold1.AddXY(t1, Series1.MinYValue);
  Threshold1.AddXY(t1, Series1.MaxYValue);

  Threshold2:=THorizLineSeries.Create(Self);
  Threshold2.AddXY(t2, Series1.MinYValue);
  Threshold2.AddXY(t2, Series1.MaxYValue);

  tmpSeries1:=TPointSeries.Create(Self);
  tmpSeries1.FunctionType:=TCrossPointsFunction.Create(Self);
  tmpSeries1.DataSources.Clear;
  tmpSeries1.DataSources.Add(Series1);
  tmpSeries1.DataSources.Add(Threshold1);
  tmpSeries1.CheckDataSource;

  tmpSeries2:=TPointSeries.Create(Self);
  tmpSeries2.FunctionType:=TCrossPointsFunction.Create(Self);
  tmpSeries2.DataSources.Clear;
  tmpSeries2.DataSources.Add(Series1);
  tmpSeries2.DataSources.Add(Threshold2);
  tmpSeries2.CheckDataSource;

  Chart1.View3D:=False;
  Chart1.AddSeries(Series1);
  Chart1.AddSeries(Threshold1);
  Chart1.AddSeries(Threshold2);
  Chart1.AddSeries(tmpSeries1);
  Chart1.AddSeries(tmpSeries2);

  tmpSeries1.Active:=False;
  tmpSeries2.Active:=False;
end;

procedure TForm1.Button1Click(Sender: TObject);
var
    Band1       : TSeriesBandTool;
    Band2       : TSeriesBandTool;
    Color1      : THorizLineSeries;
    Color2      : THorizLineSeries;
    i1          : Integer;
    i2          : Integer;
    i           : Integer;
    tmp         : Double;
begin
  for i:=0 to tmpSeries1.Count-1 do
  begin
    tmp:=tmpSeries1.XValue[i];
    tmpSeries1.XValue[i]:=tmpSeries1.YValue[i];
    tmpSeries1.YValue[i]:=tmp;
  end;

  for i:=0 to tmpSeries2.Count-1 do
    begin
    tmp:=tmpSeries2.XValue[i];
    tmpSeries2.XValue[i]:=tmpSeries2.YValue[i];
    tmpSeries2.YValue[i]:=tmp;
  end;

  tmpSeries1.RefreshSeries;
  tmpSeries2.RefreshSeries;

  Color1:=THorizLineSeries.Create(Self);
  i2:=0;
  for i1:=0 to Series1.Count-1 do
  begin
    while (tmpSeries1.YValue[i2]<Series1.YValue[i1]) and (i2<tmpSeries1.Count) do
    begin
      Color1.AddXY(tmpSeries1.XValue[i2], tmpSeries1.YValue[i2]);
      inc(i2);
    end;

    if Series1.XValue[i1]>t1 then
      Color1.AddXY(Series1.XValue[i1], Series1.YValue[i1]);
  end;

  Color2:=THorizLineSeries.Create(Self);
  i2:=0;
  for i1:=0 to Series1.Count-1 do
  begin
    while (tmpSeries2.YValue[i2]<Series1.YValue[i1]) and (i2<tmpSeries2.Count) do
    begin
      Color2.AddXY(tmpSeries2.XValue[i2], tmpSeries2.YValue[i2]);
      inc(i2);
    end;

    if Series1.XValue[i1]<t2 then
      Color2.AddXY(Series1.XValue[i1], Series1.YValue[i1]);
  end;

  Band1:=TSeriesBandTool.Create(Self);
  Band1.Series:=Color1;
  Band1.Series2:=Threshold1;

  Band2:=TSeriesBandTool.Create(Self);
  Band2.Series:=Threshold2;
  Band2.Series2:=Color2;

  Chart1.AddSeries(Color1);
  Chart1.AddSeries(Color2);
  Chart1.Tools.Add(Band1);
  Chart1.Tools.Add(Band2);

  Color1.Active:=False;
  Color2.Active:=False;
end;

end.


